# coding: utf-8

"""
    Keap REST API

    Keap REST Core Service

    The version of the OpenAPI document: 2.70.0.804890
    Contact: api@keap.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class EmailTemplate(BaseModel):
    """
    EmailTemplate
    """ # noqa: E501
    bcc_address: Optional[StrictStr] = Field(default=None, description="The bcc address of the email")
    categories: Optional[List[StrictStr]] = Field(default=None, description="The categories associated with the email")
    cc_address: Optional[StrictStr] = Field(default=None, description="The cc address of the email")
    content_type: Optional[StrictStr] = Field(default=None, description="The content type of the email")
    from_address: Optional[StrictStr] = Field(default=None, description="The from address of the email")
    html_body: Optional[StrictStr] = Field(default=None, description="The HTML body of the email")
    merge_context: Optional[StrictStr] = Field(default=None, description="The merge context of the email")
    piece_title: Optional[StrictStr] = Field(default=None, description="The title of the piece")
    subject: Optional[StrictStr] = Field(default=None, description="The subject of the email")
    text_body: Optional[StrictStr] = Field(default=None, description="The text body of the email")
    to_address: Optional[StrictStr] = Field(default=None, description="The to address of the email")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["bcc_address", "categories", "cc_address", "content_type", "from_address", "html_body", "merge_context", "piece_title", "subject", "text_body", "to_address"]

    @field_validator('content_type')
    def content_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['TEXT', 'HTML', 'MULTIPART']):
            raise ValueError("must be one of enum values ('TEXT', 'HTML', 'MULTIPART')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EmailTemplate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EmailTemplate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bcc_address": obj.get("bcc_address"),
            "categories": obj.get("categories"),
            "cc_address": obj.get("cc_address"),
            "content_type": obj.get("content_type"),
            "from_address": obj.get("from_address"),
            "html_body": obj.get("html_body"),
            "merge_context": obj.get("merge_context"),
            "piece_title": obj.get("piece_title"),
            "subject": obj.get("subject"),
            "text_body": obj.get("text_body"),
            "to_address": obj.get("to_address")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


